/*
** PREPARE.C - This is the module containing the code for SQL for
** preparing SQL Commands and other functions prior to execution.
**
*/

//      -       -       -       -       -       -       -       -       -

#include "sample.h"
#include <dos.h>

//      -       -       -       -       -       -       -       -       -

//  Allocate a SQL statement

RETCODE SQL_API SQLAllocStmt(
	LPDBC   lpdbc,
	HSTMT FAR *phstmt)
{
	LPSTMT  lpstmt;
    HANDLE  hstmt;

    hstmt = GlobalAlloc (GMEM_MOVEABLE | GMEM_ZEROINIT, sizeof (STMT));
    if (hstmt == NULL || (lpstmt = (LPSTMT)GlobalLock (hstmt)) == NULL)
    {
	*phstmt = SQL_NULL_HSTMT;
	return SQL_ERROR;
    }
    *phstmt = lpstmt;
	return SQL_SUCCESS;
}

//      -       -       -       -       -       -       -       -       -

RETCODE SQL_API SQLFreeStmt(
	LPSTMT  lpstmt,
    UWORD   fOption)
{
    if (fOption == SQL_DROP)
    {
	GlobalUnlock (LOWORD(GlobalHandle (FP_SEG(lpstmt))));
	GlobalFree (LOWORD(GlobalHandle (FP_SEG(lpstmt))));
    }
	return SQL_SUCCESS;
}

//      -       -       -       -       -       -       -       -       -

//  Perform a Prepare on the SQL statement

RETCODE SQL_API SQLPrepare(
	LPSTMT  lpstmt,
	UCHAR FAR *szSqlStr,
	SDWORD  cbSqlStr)
{
	return SQL_SUCCESS;
}

//      -       -       -       -       -       -       -       -       -

//  Set parameters on a statement handle

RETCODE SQL_API SQLSetParam(
	LPSTMT  lpstmt,
	UWORD   ipar,
	SWORD   fCType,
	SWORD   fSqlType,
	UDWORD  cbColDef,
	SWORD   ibScale,
	PTR     rgbValue,
	SDWORD FAR *pcbValue)
{
	return SQL_SUCCESS;
}

//      -       -       -       -       -       -       -       -       -

//  Returns the description of a parameter marker.

RETCODE SQL_API SQLDescribeParam(
	LPSTMT  lpstmt,
	UWORD   ipar,
	SWORD FAR *pfSqlType,
	UDWORD FAR *pcbColDef,
	SWORD FAR *pibScale,
    SWORD FAR *pfNullable)
{
	return SQL_SUCCESS;
}

//      -       -       -       -       -       -       -       -       -

//  Sets multiple values (arrays) for the set of parameter markers.

RETCODE SQL_API SQLParamOptions(
	LPSTMT  lpstmt,
    UDWORD  crow,
    UDWORD FAR *pirow)
{
	return SQL_SUCCESS;
}

//      -       -       -       -       -       -       -       -       -

//  Returns the number of parameter markers.

RETCODE SQL_API SQLNumParams(
	LPSTMT  lpstmt,
    SWORD FAR *pcpar)
{
	return SQL_SUCCESS;
}

//      -       -       -       -       -       -       -       -       -

//  Sets options that control the behavior of cursors.

RETCODE SQL_API SQLSetScrollOptions(
	LPSTMT  lpstmt,
    UWORD   fConcurrency,
    SDWORD  crowKeyset,
    UWORD   crowRowset)
{
	return SQL_SUCCESS;
}

//      -       -       -       -       -       -       -       -       -

//  Set the cursor name on a statement handle

RETCODE SQL_API SQLSetCursorName(
	LPSTMT  lpstmt,
	UCHAR FAR *szCursor,
	SWORD   cbCursor)
{
	return SQL_SUCCESS;
}

//      -       -       -       -       -       -       -       -       -

//  Return the cursor name for a statement handle

RETCODE SQL_API SQLGetCursorName(
	LPSTMT  lpstmt,
	UCHAR FAR *szCursor,
	SWORD   cbCursorMax,
	SWORD FAR *pcbCursor)
{
	return SQL_SUCCESS;
}
